//+------------------------------------------------------------------+
//|                                                       TEST 4.mq4 |
//|                                                        ARRESSS23 |
//|                                          driss.elbaz23@gmail.com |
//+------------------------------------------------------------------+
#property copyright "ARRESSS23"
#property link      "driss.elbaz23@gmail.com"
#property version   "1.00"
#property strict

extern double lot_buy;
extern double lot_sell_1;
extern double lot_sell_2;
extern int slippage;
extern int distance;
extern int magic;

int ticket_buy;
int ticket_sell_1;
int ticket_sell_2;
double price_open_buy;
double pt;
bool trade=true;


bool AreThereOrders()
  {
   int i;
   for(i=OrdersTotal()-1; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         continue;
      if(OrderMagicNumber()==magic && OrderSymbol()==Symbol())
        {
         return (true);
        }
     }
   return (false);
  }


void error_fonction (int position)
  {
   if(position<0)
      {
       Print("OrderSend failed with error #",GetLastError());
      }
      else
      {
      Print("OrderSend placed successfully"); 
      }
  }

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  { 
  if(Digits==5||Digits==4) 
    { 
     pt=0.0001; 
    } 
  else 
    { 
     pt=0.01; 
    }

   
   return(INIT_SUCCEEDED);
  }


//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  }


//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  { 

   
// envoyer message d alert en cas perte de connection avec le serveur :  
   if ( IsConnected () == false )
     {
      Comment ( "ALERT : ECHEC OF CONNECTION" );
      return;
     }
   
// Execution du 1er ordre d achat :
   if(AreThereOrders()==false)
    {
     ticket_buy=OrderSend(Symbol(),OP_BUY,lot_buy,Ask,slippage,(Ask-(distance*2*pt)),(Ask+(distance*2*pt)),NULL,0,0,0);     
     error_fonction (ticket_buy); 
    }
   
   
  
// Collecter les informations sur le 1er ordre :
   if(OrderSelect(ticket_buy,SELECT_BY_TICKET)==True) //renvoyer le prix d'achat 
     {
   price_open_buy=OrderOpenPrice();                //stocker le prix d'achat dans la variable : price_open_buy
     }  

   
// Execution du 2nd ordre de vente lorsque le prix monte :
   if ( ( NormalizeDouble(Ask,5) - (NormalizeDouble(price_open_buy,5)+NormalizeDouble((distance*pt),5)) ) >= 0.00001 ) 
            {
              if (trade==true)
                 {
                   ticket_sell_1=OrderSend(Symbol(),OP_SELL,lot_sell_1,Bid,slippage,(Bid+(distance*pt)),(Bid-(distance*3*pt)),NULL,0,0,0);      
                   trade=false;
                   error_fonction (ticket_sell_1);
                 }
               
            }
        
// Execution du 2nd ordre de vente lorsque le prix descend :   
   if ( ( NormalizeDouble(Bid,5) - (NormalizeDouble(price_open_buy,5)-NormalizeDouble((distance*pt),5)) ) <= 0.00001 )
           {
            if (trade==true)
             {
               ticket_sell_2=OrderSend(Symbol(),OP_SELL,lot_sell_2,Bid,slippage,(Bid+(distance*3*pt)),(Bid-(distance*pt)),NULL,0,0,0);      
               trade=false;
               error_fonction (ticket_sell_2);         
             }
        
           }
     

  }

//+------------------------------------------------------------------+
